-- Test translate_campsite
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(14);

set search_path to camper, public;

select has_function('camper', 'translate_campsite', array['integer', 'text', 'text', 'text']);
select function_lang_is('camper', 'translate_campsite', array['integer', 'text', 'text', 'text'], 'sql');
select function_returns('camper', 'translate_campsite', array['integer', 'text', 'text', 'text'], 'void');
select isnt_definer('camper', 'translate_campsite', array['integer', 'text', 'text', 'text']);
select volatility_is('camper', 'translate_campsite', array['integer', 'text', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'translate_campsite', array['integer', 'text', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'translate_campsite', array['integer', 'text', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'translate_campsite', array['integer', 'text', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'translate_campsite', array['integer', 'text', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_i18n cascade;
truncate campsite cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (3, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, media_id, name, max_campers, bookable_nights)
values (11, 1, 3, 'Type A', 5, '[1, 7]')
;

insert into campsite (campsite_id, company_id, campsite_type_id, label, info1, info2, active)
values (21, 1, 11, 'A1', '<p>Info 1</p>', '<p>Info 2</p>', true)
     , (22, 1, 11, 'B1', '<p>Info 1</p>', '<p>Info 2</p>', true)
;

insert into campsite_i18n (campsite_id, lang_tag, info1, info2)
values (22, 'ca', '<p>i1</p>', '<p>i2</p>')
     , (22, 'en', '<p>i1</p>', '<p>i2</p>')
;

select lives_ok(
	$$ select translate_campsite(21, 'ca', '<p>Informació 1</p>', '') $$,
	'Should be able to translate the first type'
);

select lives_ok(
	$$ select translate_campsite(22, 'es', '', '<p>Información 2</p>') $$,
	'Should be able to translate the second type'
);

select lives_ok(
	$$ select translate_campsite(22, 'ca', '<p>Informació 1</p>', '<p>Informació 2</p>') $$,
	'Should be able to overwrite the catalan translation of the second type'
);

select lives_ok(
	$$ select translate_campsite(22, 'en', null, null) $$,
	'Should be able to overwrite the english translation of the second type with all empty values'
);

select bag_eq(
	$$ select campsite_id, lang_tag, info1::text, info2::text from campsite_i18n $$,
	$$ values (21, 'ca', '<p>Informació 1</p>', null)
	        , (22, 'ca', '<p>Informació 1</p>', '<p>Informació 2</p>')
	        , (22, 'es', null, '<p>Información 2</p>')
	        , (22, 'en', null, null)
	$$,
	'Should have added and updated all translations.'
);

select *
from finish();

rollback;
